//---------------------------------------------------------------------------
//Copyleft 1998 ACME Inc 1998  (Tugomira associated)
//---------------------------------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <conio.h>
#include <time.h>
#include <dos.h>

#define MAXARR 100
#define MINVALORE -400
#define MAXVALORE 400

//---------------------------------------------------------------------------
typedef struct
{
 char pos;
 char max;
 char arr[MAXARR];
} Contiguo;

typedef struct
{
 Contiguo libere;   // Posizioni libere
 Contiguo loci;     // Serie ancora fattibili (puntatori alla mappa dei loci)
 int vloci[MAXARR];// Valore dei loci (serie fattibili)
 char scac[50];     // Scacchiera
} Stato;

typedef struct
{
 int migliore;
 int valore;
} Risultato;
//---------------------------------------------------------------------------
const char *piroli = " 0x";
enum pirolis {NIENTE,PALLA,CROCE};
typedef char serie[4];
serie mappa[MAXARR];
Stato ora;
//---------------------------------------------------------------------------
#define avversario(chi) (char)(chi % 2 +1)
int calcolaValori(Stato *s);
//---------------------------------------------------------------------------
void initmappa(serie *map,char *nloci)
{
 char i,j,h ;
 *nloci = 0;

 // orizzontali
 for (j=1; j<49; j += (char)7)
  for (h=0; h<4; h++)
  {
   (*nloci)++;
   for (i=0; i<4; i++)
    map[*nloci][i] = (char)(j + i + h);
  }

 // verticali
 for (j=1; j<=7; j++)
  for (h=0; h<4; h++)
   {
    (*nloci)++;
    for (i=0; i<4; i++)
     map[*nloci][i] = (char) (j + i*7 + h*7);
   }

 // diagonali
 for (j=2; j<=4; j++)  // DEB mancano diagonali principali j:1,4
   for (h=0; h<(5-j); h++)
    {
    for (i=0; i<4; i++)
     {
      map[*nloci+4][i]  =(char) (j +  h*8 + i*8) ;    		// NE
      map[*nloci+1][i]=(char) ((j-1)*7 +1 +  h*8 + i*8) ;   // SO
      map[*nloci+2][i]=(char) ((8-j) +  h*6 + i*6) ;       	// NO
      map[*nloci+3][i]=(char) ((j*7) +  h*6 + i*6 );   		// SE
     }
    *nloci += (char) 4;
    }

 //diagonali principali
   j = 1;
   for (h=0; h<(5-j); h++)
    {
    for (i=0; i<4; i++)
     {
      map[*nloci+1][i]  =(char) (j +  h*8 + i*8) ;    		// NE
      map[*nloci+2][i]=(char) ((8-j) +  h*6 + i*6) ;       	// NO
     }
    *nloci += (char) 2;
    }
}

//---------------------------------------------------------------------------
// L'elemento 0 e' inutilizzato: pos = posizione ultimo e numero elementi
int pushCg(Contiguo *p, char c)
{
 if (p->pos < (p->max -1)) p->arr[++p->pos] = c;
 else return 0;
 return p->pos;
}
//---------------------------------------------------------------------------
// estrae l'elemento c dall'array contiguo p nella posizione dove
int popCg(Contiguo *p, char *c, int dove)
{
 assert(dove > 0 && dove <= p->pos);

 assert(p->pos < p->max);
 if (p->pos > 0 )
 {
   *c = p->arr[dove];  
   p->arr[dove] = p->arr[p->pos--];
 }
 else return 0;
 return p->pos;
}
//---------------------------------------------------------------------------
void initCg(Contiguo *p)
{
 p->max = MAXARR;
 p->pos =0;
}
//---------------------------------------------------------------------------
int evuota(Contiguo p)
{
 return p.pos == 0;
}
//---------------------------------------------------------------------------
int _cambia(int ilib, char chi,Stato *s)
{
 char pos;
 assert(ilib >0 && ilib <50);
 assert(chi>0 && chi<3);
 assert(s->scac[s->libere.arr[ilib]] == NIENTE);
 popCg(&(s->libere),&pos,ilib);
 assert( pos>0 && pos <=49);
 s->scac[pos] =  (char)chi;
 return calcolaValori(s);
}
//---------------------------------------------------------------------------
// Mette il pirolo del giocatore 'chi' nella posizione (x,y)
int cambiaXY(int x,int y,char chi,Stato *s)
{
 int posizione;
 char ilib;
 
 assert(x>0 && x<8 && y>0 && y<8);    //DEB dentro la scacchiera
 posizione = (y-1)*7 + x ;
 assert(posizione >0 && posizione <=50);
 for (ilib=s->libere.pos;
      ilib>0 && (s->libere.arr[ilib] != posizione);
      ilib--);
 assert(ilib > 0);
 return _cambia(ilib,chi,s);
}
//---------------------------------------------------------------------------
void visualizza(char num,char chi,int eur,Stato s,double tempo)
{
 int i,j;
 clrscr();
 printf("Euristica: %d\r\n",eur);

 printf("Valori orizz.: ");
 for (i=1; i<29; i++)
  printf("%d",s.vloci[i]+4);

 printf("\n\r Valori Vert.: ");
 for (i=29; i<57; i++)
  printf("%d",s.vloci[i]+4);

 printf("\n\rValori Diago.: ");
 for (i=57; i<=88; i++)
  printf("%d",s.vloci[i]+4);

  /*
 printf("\n\r libere    :");
 for (i=1; i<=s.libere.pos; i++)
  printf("_%d", s.libere.arr[i]);
  */

 printf("\r\n   1 2 3 4 5 6 7   \n\r");
 printf("  +-+-+-+-+-+-+-+  \n\r");
 for (i=1; i<8; i++)
 {
  printf(" %d|",i);
  for (j=1; j<8; j++)
  {
   putc(piroli[s.scac[(i-1)*7 + j]],stdout);
   putc('|',stdout);
  }
  printf("  \r\n");
  printf("  +-+-+-+-+-+-+-+  \n\r");
 }
 printf("Tempo: %f secondi\n",tempo);
 printf("\r\n Mossa num. %d Gioca %c\n\r",num,piroli[chi]);
}
//---------------------------------------------------------------------------
void inputXY(char *x, char *y)
{
 printf(" XY: \r\n");
 *x=0; *y=0;
 while (!(*x>0 && *x<8 && *y>0 && *y<8 && ora.scac[(*y-1) * 7 + *x] == NIENTE))
 {
  *x = (char) (getch()-'0');
  *y = (char) (getch()-'0');
 }
}
//---------------------------------------------------------------------------
void radice(char nloci,Stato *s)
{
 int j;

 initCg(&(s->libere));
 initCg(&(s->loci));
 for (j =1; j<=49; j++)
  pushCg(&(s->libere), (char)j);
 for (j =1; j<=nloci; j++)
  pushCg(&(s->loci), (char)j);
 for (j=1; j<=49; j++)
   s->scac[j] = 0;
}
//---------------------------------------------------------------------------
// Calcola i valori dei loci esce con il valore vittoria (0 : nessuno vince)
enum values  {VUOTO,ENTRAMBI=5} ;
enum vittorie  {VINCONOCROCI = -1,NESSUNO,VINCONOPALLE };

int calcolaValori(Stato *s)
{
  int valore;
 char
  xyz,
  pirolo,ncroci,npalle,
  p,       // scandisce i 4 valori della mappa di una serie
  pmappa,  // punta alla mappa indicando un locus
  loci;    // scandisce loci (serie fattibili) in libere

 for (loci=1; loci <= s->loci.pos; loci++)
 {
  npalle = 0;
  ncroci = 0;
  pmappa = s->loci.arr[loci];
  for (p=0;p<4;p++)
  {
   assert(pmappa <= 88);
   pirolo = s->scac[mappa[pmappa][p]];

   if (pirolo == PALLA) npalle++;
   if (pirolo == CROCE) ncroci++;
  }
  //DEBUG mettere parte di questo if dentro il for aggiungendoli break
  //potrebbe aumentare la velocita
  if ((npalle == 0) && (ncroci == 0))
   valore = VUOTO;  						// nessun pirolo
  else if (npalle>0 && ncroci>0)
  {
   valore = ENTRAMBI;  						// piroli dei due tipi
   popCg(&(s->loci),&xyz,loci);             // toglie lista loci
  }
  else if  (ncroci>0)
   valore = -1 * ncroci;           			// solo croci
  else valore = (char) npalle;              // solo palle

  s->vloci[pmappa] = valore;

  if (valore == 4 )
   return VINCONOPALLE;
  if (valore == -4)
   return VINCONOCROCI;
 }
 return NESSUNO;
}
//---------------------------------------------------------------------------
#define  valore(loci) s->vloci[s->loci.arr[loci]]
int euristica(char chi,const Stato *s)
{
 char loci,i;
 int nval[10];

 int out = 0;
 for (i = 0; i<10; i++) nval[i] = 0;
 for (loci=1; loci <= s->loci.pos; loci++)
 {
  nval[valore(loci)+4]++; // i-esimo = numero di loci di valore i - 4
  out += valore(loci);

  if (valore(loci) == 4 || valore(loci) == -4)
  {
   out = 100*valore(loci);       // trovato vittoria: esce subito
   if (chi == PALLA) return out;
   else return out * (-1);
  }
 }
 //DEB studiare valori e struttura casi particolari, quale di questi
 // e piu importante?
 if (nval[7] > 0)
  out = 50 + nval[7]*10;  // tre: vincita prossima
 if (nval[1] > 0)
  out = -50 - nval[1]*10; // tre avversario: perdita prossima
 //out += nval[6] - nval[2];
 // normalizzazione segno
 if (chi == PALLA) return out;
 else return out * (-1);
}
//---------------------------------------------------------------------------
// Risolutore minimale: calcola la migliore euristica statica per tutte
// le posizioni giocabili restituisce posizione
Risultato Spaccamatic_0(char chisono,Stato *s)
{
 Risultato mossa;
 int lib,eur,
  massimo = MINVALORE,
  maxlib = -1;
 Stato nuovostato;

 for(lib = 1; lib < s->libere.pos;lib++)  // tutte le caselle libere
 {
  nuovostato = ora;
  _cambia(lib,chisono,&nuovostato);
  eur = euristica(chisono,&nuovostato);
  if (eur > massimo)
  {
   maxlib = lib;   		// indice in liberi
   massimo = eur;      	// massima euristica
  }
 }

 assert(maxlib > 0);
 mossa.migliore = maxlib;
 mossa.valore = massimo;
 return mossa;
}
//---------------------------------------------------------------------------
// Restituisce tutte le mosse fattibili in una certa posizione di gioco
Contiguo gen_mosse(int giocatore,Stato s)
{
  return s.libere;
}
//---------------------------------------------------------------------------
// Termina il processo ricorsivo Minimax
int abbastanza_profondo( int prof,int valore, Stato s)
{
 return  ((prof > 2) );
 // DEB anche (valore >= MAXVALORE)  ?
}

//---------------------------------------------------------------------------
// Algoritmo Minimax applicato all'albero delle mosse
Risultato minimax(int prof,char giocatore,Stato pos)
 {
  Risultato ris_succ;
  Contiguo successori;
  Stato nuova_pos;
  int valore_migliore,nuovo_valore,mossa_migliore,succ;

  if (abbastanza_profondo(prof,
  		ris_succ.valore = euristica(giocatore,&pos),pos))
  {
    ris_succ.migliore = 0; //nil
  	return ris_succ;
  }
  else if (evuota(successori = gen_mosse(giocatore,pos)))
    return ris_succ;
  else
  {

   valore_migliore = MINVALORE;
   mossa_migliore = 1;
   for (succ =1; succ<=successori.pos;succ++)
   {
    nuova_pos = pos;
    _cambia(succ, giocatore,&nuova_pos);
    ris_succ = minimax(prof+1,avversario(giocatore),nuova_pos);
    nuovo_valore = -1 * ris_succ.valore;
    if (nuovo_valore > valore_migliore)
    {
     valore_migliore = nuovo_valore;
     mossa_migliore = succ;
    }
   }
   ris_succ.valore = valore_migliore;
   ris_succ.migliore = mossa_migliore;
   
   if (prof == -1)  // DEB
   {
    visualizza(prof,giocatore,ris_succ.valore,pos,0);
    printf("ready");
      getch();
   }
   return  ris_succ;
  }
 }
//---------------------------------------------------------------------------

int main(int argc, char **argv)
{
	int eur,res;
	char x,y,chi,nmosse,nloci;
    Risultato mossa;
    time_t first, second;

    initmappa(mappa,&nloci);
    radice(nloci,&ora);

    nmosse = 0;
    chi = 1;
    res = 0;
    visualizza(nmosse,chi,0,ora,0);
    while ((res == 0) && (nmosse<49))
    {
      eur = euristica(chi,&ora);
      first = time(NULL);

      if (chi == 2)
      {
       inputXY(&x,&y);
       res = (char) cambiaXY(x,y,chi,&ora);
      }
      else if (chi == 3)
      {
       mossa = Spaccamatic_0( chi,&ora);
       res =_cambia(mossa.migliore,chi,&ora);
      }
      else
      {
       mossa = minimax(0,chi,ora);
       res =_cambia(mossa.migliore,chi,&ora);
      }
      second = time(NULL);
      printf("ready");
      //getch();
      visualizza(nmosse,chi,eur,ora,difftime(second,first));
      chi = avversario(chi);
      nmosse++;
    }
    visualizza(nmosse,chi,eur,ora,difftime(second,first));
    if (res == VINCONOPALLE) printf("CHE PALLE!!!");
    else if (res == VINCONOCROCI) printf("CROCE E DELIZIA");
    else if (nmosse >= 49) printf("NONE OF THE ABOVE");
    getch();

	return 0;
}
//---------------------------------------------------------------------------


